---
title: "Tables de hachage"
date: "2022-01-19"
patat:
  eval:
    tai:
      command: fish
      fragment: false
      replace: true
    ccc:
      command: fish
      fragment: false
      replace: true
  images:
    backend: auto
...

# Exercice 3

* Stocker les numéros de téléphones internes d'une entreprise suivants dans un
tableau de 10 positions.
* Les numéros sont compris entre 100 et 299.
* Soit $N$ le numéro de téléphone, la fonction de hachage est
$$
h(N)=N\mod 10.
$$
* La fonction de gestion des collisions est
$$
C_1(N,i)=(h(N)+3\cdot i)\mod 10.
$$
* Placer 145, 167, 110, 175, 210, 215 (mettre son état à occupé).
* Supprimer 175 (rechercher 175, et mettre son état à supprimé).
* Rechercher 35.
* Les cases ni supprimées, ni occupées sont vides.
* Expliquer se qui se passe si on utilise?
$$
C_1(N,i)=(h(N)+5\cdot i)\mod 10.
$$

# Préambule

* On considère pas le cas du chaînage en cas de collisions.
* L'insertion est construite avec une forme du type

    ```C
    index = h(key);
    while (table[index].state == OCCUPIED && table[index].key != key) {
       index = (index + k) % table_size; // attention à pas dépasser
    }
    table[index].key = key;
    table[index].state = OCCUPIED;
    ```
* Gestion de l'état d'une case *explicite*

    ```C
    typedef enum {EMPTY, OCCUPIED, DELETED} state;
    ```

# L'insertion

## Pseudocode?

. . .

```C
insert(table, key, value) {
    index = hash de la clé;
    index = si "index" est déjà occupé et la clé correspondante est pas "key"
        gérer la collision;

    changer l'état de la case à "index" à occupé;
    changer la valeur de la case "index" à value;
}
```

# La suppression

## Pseudocode?

. . .

```C
value_t remove(table, key) {
    index = hash de la clé;
    tant que l'état de la case est pas "vide"
        si "index" est occupé et la clé est "key" 
            changer l'état de la case à supprimé
        sinon
            index = rehash
}
```

# La recherche

## Pseudocode?

. . .

```C
bool search(table, key, value) {
    index = hash de la clé;
    tant que l'état de la case est pas "vide"
        si "index" est occupé et la clé est "key" 
            retourner vrai
        sinon
            index = rehash
}
```

